      subroutine gridcheck_nests(error)
C                                  o
********************************************************************************
*                                                                              *
*                               MM5 VERSION                                    *
*                                                                              *
*     This routine checks the grid specification for the nested model domains. *
*     It is similar to subroutine gridcheck, which checks the mother domain.   *
*                                                                              *
*     Authors: A. Stohl, G. Wotawa                                             *
*                                                                              *
*     30 December 1998                                                         *
********************************************************************************

      include 'includepar'
      include 'includecom'

      integer i,j,k,l,ifn,ifield,iumax,iwmax,nsigmahalfn
      integer nuvzn,nwzn
      integer iprojmother,nxmother,nymother
      real dxmother,dymother,xloncmother,ylatcmother,truelatmother
      real conefmother,p00mother,ptopmother,ts0mother,tamother
      real sigmahalfn(nuvzmax),xpos1,ypos1
      real xhelp1,xhelp2,yhelp1,yhelp2
      logical error

* VARIABLES AND ARRAYS NEEDED FOR GRIB DECODING

      integer isec0(2),isec1(56),isec2(512),isec3(2),isec4(64)
      integer inbuff(jpack),ilen,ierr,iword,lunit
      real zsec2(128),zsec3(2),zsec4(jpunp)
      character*1 yoper,fname1*120
      data yoper/'D'/

      error=.false.
      xresoln(0)=1.       ! resolution enhancement for mother grid
      yresoln(0)=1.       ! resolution enhancement for mother grid

C Loop about all nesting levels
*******************************

      do 300 l=1,numbnests

        iumax=0
        iwmax=0
*
        if(ideltas.gt.0) then
          ifn=1
        else
          ifn=numbwf
        endif
*
* OPENING OF DATA FILE (GRIB CODE)
*
        fname1=path(numpath+2*(l-1)+1)
     &    (1:len(numpath+2*(l-1)+1))//wfnamen(l,ifn)
5       call pbopen(lunit,fname1,'r',ierr)
        if(ierr.lt.0) goto 999

        ifield=0   
10        ifield=ifield+1
*
* GET NEXT FIELDS
*
          call pbgrib(lunit,inbuff,jpack,ilen,ierr)
          if(ierr.eq.-1) goto 30    ! EOF DETECTED
          if(ierr.lt.-1) goto 999   ! ERROR DETECTED
 
          ierr=1
          call gribex(isec0,isec1,isec2,zsec2,isec3,zsec3,isec4,
     +    zsec4,jpunp,inbuff,jpack,iword,yoper,ierr)
          if (ierr.ne.0) goto 999   ! ERROR DETECTED

          if(ifield.eq.1) then
            open(unitwind,file=path(numpath+2*(l-1)+1)
     &        (1:len(numpath+2*(l-1)+1))//'GRID.TXT',
     &        status='old',err=996)

            read(unitwind,*) iprojmother
            read(unitwind,*) nxn(l)
            read(unitwind,*) nyn(l)
            read(unitwind,*) nsigmahalfn
            read(unitwind,*) dxn(l)
            dxn(l)=dxn(l)*1000.   ! Reference unit = m
            dyn(l)=dxn(l)  ! Only dx=dy possible in MM5...
            read(unitwind,*) nxmother
            read(unitwind,*) nymother
            read(unitwind,*) dxmother
            dxmother=dxmother*1000.
            dymother=dxmother
            read(unitwind,*) xpos1
            read(unitwind,*) ypos1
            read(unitwind,*) xloncmother
            read(unitwind,*) ylatcmother
            read(unitwind,*)
            read(unitwind,*)
            read(unitwind,*)
            read(unitwind,*)
            read(unitwind,*) truelatmother
            read(unitwind,*) conefmother
            read(unitwind,*) p00mother
            read(unitwind,*) ptopmother
            read(unitwind,*) ts0mother
            read(unitwind,*) tamother
            do 15 k=1,nsigmahalfn
15            read(unitwind,*) sigmahalfn(nsigmahalfn-k+1)
            xlon0n(l)=-0.5*float(nxmother-1)*dxmother+
     &        (xpos1-1.0)*dxmother
            ylat0n(l)=-0.5*float(nymother-1)*dymother+
     &        (ypos1-1.0)*dymother
            close(unitwind)
          endif

          k=isec1(8)
          if(isec1(6).eq.131) iumax=max(iumax,nsigmahalf-k+1)
          if(isec1(6).eq.135) iwmax=max(iwmax,nsigmahalf-k+2)

          if(isec1(6).eq.129) then
            do 20 j=0,ny-1
              do 20 i=0,nx-1
20              oron(i,j,l)=zsec4(nx*(ny-j-1)+i+1)
          endif

          goto 10                  ! READ NEXT LEVEL OR PARAMETER
*
* CLOSING OF INPUT DATA FILE
*
30      call pbclose(lunit,ierr)  ! FINISHED READING/CLOSING GRIB FILE

        nuvzn=iumax
        nwzn=iwmax

        if (nxn(l).gt.nxmaxn) then                         
      write(*,*) 'FLEXTRA error: Too many grid points in x direction.'
      write(*,*) 'Reduce resolution of wind fields (file GRIDSPEC)'
      write(*,*) 'for nesting level ',l

          error=.true.
          return
        endif

        if (nyn(l).gt.nymaxn) then                         
      write(*,*) 'FLEXTRA error: Too many grid points in y direction.'
      write(*,*) 'Reduce resolution of wind fields (file GRIDSPEC)'
      write(*,*) 'for nesting level ',l
          error=.true.
          return
        endif

        if ((nuvzn.gt.nuvzmax).or.(nwzn.gt.nwzmax)) then
      write(*,*) 'FLEXTRA error: Nested wind fields have too many'//
     +'vertical levels.'
      write(*,*) 'Problem was encountered for nesting level ',l
          error=.true.
          return
        endif

C Output of grid info
*********************

      write(*,'(a,i2)') 'Nested domain #: ',l
      write(*,'(a,f10.1,a1,f10.1,a,f10.1)') '  Longitude range: ',
     +xlon0n(l),' to ',xlon0n(l)+(nxn(l)-1)*dxn(l),
     +'   Grid distance: ',dxn(l)
      write(*,'(a,f10.1,a1,f10.1,a,f10.1)') '  Latitude range:  ',
     +ylat0n(l),' to ',ylat0n(l)+(nyn(l)-1)*dyn(l),
     +'   Grid distance: ',dyn(l)
      write(*,*)


C Determine, how much the resolutions in the nests are enhanced as
C compared to the mother grid
******************************************************************

        xresoln(l)=dx/dxn(l)
        yresoln(l)=dy/dyn(l)

C Determine the mother grid coordinates of the corner points of the
C nested grids
C Convert first to geographical coordinates, then to grid coordinates
*********************************************************************

        xhelp1=xlon0n(l)
        xhelp2=xlon0n(l)+float(nxn(l)-1)*dxn(l)
        yhelp1=ylat0n(l)
        yhelp2=ylat0n(l)+float(nyn(l)-1)*dyn(l)

        xln(l)=(xhelp1-xlon0)/dx
        xrn(l)=(xhelp2-xlon0)/dx
        yln(l)=(yhelp1-ylat0)/dy
        yrn(l)=(yhelp2-ylat0)/dy

C Check, whether the heights of the model levels of the nested
C wind fields are consistent with those of the mother domain.
C If not, terminate model run.
**************************************************************

        if(nsigmahalf.ne.nsigmahalfn) then
      write(*,*) 'FLEXTRA error: The wind fields of nesting level',l
      write(*,*) 'are not consistent with the mother domain:'
      write(*,*) 'Different numbers of vertical levels detected.'
          error=.true.
          return
        endif
        do 75 i=1,nsigmahalf
          if(sigmahalf(i).ne.sigmahalfn(i)*zdirect) then
      write(*,*) 'FLEXTRA error: The wind fields of nesting level',l
      write(*,*) 'are not consistent with the mother domain:'
      write(*,*) 'Differences in vertical levels detected.'
            error=.true.
            return
          endif
75        continue

*
* CHECK FULL CONSISTANCY OF MOTHER DOMAIN AND NESTS
*
* I CHECK WETHER THE PROJECTIONS OF MOTHER DOMAIN AND NESTS ARE
*   THE SAME
*
        if((iproj.ne.iprojmother).or.(xloncenter.ne.xloncmother).or.
     &     (ylatcenter.ne.ylatcmother).or.(truelat.ne.truelatmother)
     &     .or.(conef.ne.conefmother)) then
      write(*,*) 'FLEXTRA error: The projections used for the nests'
      write(*,*) 'is different from that used in the mother domain.'
      write(*,*) 'That must come from different, incompatible MM5'
      write(*,*) 'Runs. Please check....'
            error=.true.
            return
        endif
* II CHECK WETHER THE NON-HYDROSTATIC REFERENCE STATES OF MOTHER DOMAIN
* AND NESTS ARE THE SAME
*
        if((p00.ne.p00mother).or.(ptop.ne.ptopmother).or.
     &    (ts0.ne.ts0mother).or.(ta.ne.tamother)) then
      write(*,*) 'FLEXTRA error: The nonhydrostatic reference state'
      write(*,*) 'conditions used for the nests are different from'
      write(*,*) 'that used in the mother domain. That must come from'
      write(*,*) 'different, incompatible MM5 Runs. Please check....'
            error=.true.
            return
        endif

300     continue
      return

996   write(*,'(a)') '  FLEXPART MODEL ERROR! FILE "GRID.TXT"  '
      write(*,'(a)') '  CANNOT BE OPENED IN THE DIRECTORY      '
      write(*,'(a)') '  '//path(numpath+2*(l-1)+1)
     +  (1:len(numpath+2*(l-1)+1))
      stop

999   write(*,*)  
      write(*,*) ' ###########################################'//
     &           '###### '
      write(*,*) '       TRAJECTORY MODEL SUBROUTINE GRIDCHECK:'
      write(*,*) ' CAN NOT OPEN INPUT DATA FILE '//wfnamen(l,ifn)
      write(*,*) ' FOR NESTING LEVEL ',k
      write(*,*) ' ###########################################'//
     &           '###### '
      error=.true.

      return
      end
