      real function pp(psurf,sigma)
***********************************************************************
*                                                                     *
*                      MM5 VERSION                                    *
*                                                                     *
*             TRAJECTORY MODEL SUBROUTINE PP                          *
*                                                                     *
***********************************************************************
*                                                                     *
*             AUTHOR:      G. WOTAWA                                  *
*             DATE:        1994-04-07                                 *
*             LAST UPDATE: ----------                                 *
*                                                                     *
***********************************************************************
*                                                                     *
* DESCRIPTION: This function computes the pressure as a function of   *
*              sigma (MM5) and surface pressure.                      *
*                                                                     *
***********************************************************************
*                                                                     *
* INPUT:                                                              *
*                                                                     *
* psurf        surface pressure [Pa]                                  *
* sigma        vertical coordinate MM5                                *
*                                                                     *
***********************************************************************
*                                                                     *
* OUTPUT:                                                             *
*                                                                     *
* pp           pressure [Pa]                                          *
*                                                                     *
***********************************************************************
*
      include 'includepar'
      include 'includecom'

      real psurf,sigma
*
      pp=abs(sigma)*(psurf-ptop)+ptop

      return
      end
