      real function sigmatoh(sigma,ps0,ptop,p00,ts0,ta)
*********************************************************************** 
*                                                                     *
* CALCULATES HEIGHT OF SIGMA LAYERS IN NONHYDROSTATIC MM5             *
* RUNS                                                                *
*                                                                     *
* INPUT                                                               *
*                                                                     *
* sigma        height of sigma level (0.0-1.0)                        *
* ps0          reference surface pressure [Pa]                        *
* ptop         top pressure [Pa]                                      *
* p00          reference sea level pressure [Pa]                      *
* ts0          reference sea level temperature [K]                    *
* ta           reference temperature lapse rate [K]                   *
*                                                                     *
* OUTPUT                                                              *
*                                                                     *
* sigmatoh     height of layer [m]                                    *
*                                                                     *
*********************************************************************** 
      implicit none
      real sigmatoh,sigma,ps0,ptop,p00,ts0,ta
      real ps0star,p0,Rair,g
      parameter(Rair=287.05,g=9.81)

      ps0star=ps0-ptop
      p0=ps0star*sigma+ptop

      sigmatoh= - (Rair * ta)/(2.0*g) * (log(p0/p00)**2) -
     &            (Rair *ts0)/ g      * (log(p0/p00))

      return
      end
