      subroutine zztrafo(zt,psint,ht)
***********************************************************************
*                                                                     *
*                       MM5 VERSION                                   *
*                                                                     *
*             TRAJECTORY MODEL SUBROUTINE ZZTRAFO                     *
*                                                                     *
***********************************************************************
*                                                                     *
*             AUTHOR:      G. WOTAWA                                  *
*             DATE:        1994-04-07                                 *
*             LAST UPDATE: 1999-01-07 Adaptation to nesting           *
*                                                                     *
***********************************************************************
*                                                                     *
* DESCRIPTION: This subroutine transforms the vertical coordinate     *
*              sigma (MM5) to geometric height [m] above model        *
*              orography (relative height)                            *
*                                                                     *
***********************************************************************
*                                                                     *
* INPUT:                                                              *
*                                                                     *
* zt                         z-coordinate of point [eta (ECMWF)]      *
* psint                      surface pressure at point (xt,yt) [Pa]   *
*                                                                     *
***********************************************************************
*                                                                     *
* OUTPUT:                                                             *
*                                                                     *
* ht                         geometric height [m]                     *
*                                                                     *
***********************************************************************
*
      include 'includepar'
      include 'includecom'

      real zt,ht,psint,sigmatoh,geopot1

      geopot1=sigmatoh(abs(sigmafull(1)),psint,ptop,p00,ts0,ta)
      ht=sigmatoh(abs(zt),psint,ptop,p00,ts0,ta)-geopot1
      return
      end
